library angular2.src.core.compiler.interfaces;

import "package:angular2/src/core/facade/collection.dart" show Map;
import "package:angular2/src/core/facade/lang.dart" show global;
// This is here only so that after TS transpilation the file is not empty.

// TODO(rado): find a better way to fix this, or remove if likely culprit

// https://github.com/systemjs/systemjs/issues/487 gets closed.
var ___ignore_me = global;

/**
 * Defines lifecycle method [metadata/LifeCycleEvent#OnChanges `LifeCycleEvent.OnChanges`]
 * called after all of component's bound properties are updated.
 */
abstract class OnChanges {
  void onChanges(Map<String, dynamic> changes);
}

/**
 * Defines lifecycle method [metadata/LifeCycleEvent#OnInit `LifeCycleEvent.OnInit`]
 * called when a directive is being checked the first time.
 */
abstract class OnInit {
  void onInit();
}

/**
 * Defines lifecycle method [metadata/LifeCycleEvent#DoCheck `LifeCycleEvent.DoCheck`]
 * called when a directive is being checked.
 */
abstract class DoCheck {
  bool doCheck();
}

/**
 * Defines lifecycle method [metadata/LifeCycleEvent#OnDestroy `LifeCycleEvent.OnDestroy`]
 * called when a directive is being destroyed.
 */
abstract class OnDestroy {
  void onDestroy();
}

/**
 * Defines lifecycle method
 * [metadata/LifeCycleEvent#AfterContentInit `LifeCycleEvent.afterContentInit`]
 * called when the bindings of all its content children have been checked the first time.
 */
abstract class AfterContentInit {
  void afterContentInit();
}

/**
 * Defines lifecycle method
 * [metadata/LifeCycleEvent#AfterContentChecked `LifeCycleEvent.afterContentChecked`]
 * called when the bindings of all its content children have been checked.
 */
abstract class AfterContentChecked {
  void afterContentChecked();
}

/**
 * Defines lifecycle method
 * [metadata/LifeCycleEvent#AfterViewInit `LifeCycleEvent.afterViewInit`]
 * called when the bindings of all its view children have been checked the first time.
 */
abstract class AfterViewInit {
  void afterViewInit();
}

/**
 * Defines lifecycle method
 * [metadata/LifeCycleEvent#AfterViewChecked `LifeCycleEvent.afterViewChecked`]
 * called when the bindings of all its view children have been checked.
 */
abstract class AfterViewChecked {
  void afterViewChecked();
}
