library angular2.src.web_workers.ui.render_compiler;

import "package:angular2/src/core/di/decorators.dart" show Injectable;
import "package:angular2/src/core/render/api.dart"
    show
        RenderDirectiveMetadata,
        ProtoViewDto,
        ViewDefinition,
        RenderProtoViewRef,
        RenderProtoViewMergeMapping,
        RenderCompiler;
import "package:angular2/src/web_workers/shared/messaging_api.dart"
    show RENDER_COMPILER_CHANNEL;
import "bind.dart" show bind;
import "package:angular2/src/web_workers/shared/service_message_broker.dart"
    show ServiceMessageBrokerFactory;

@Injectable()
class MessageBasedRenderCompiler {
  ServiceMessageBrokerFactory _brokerFactory;
  RenderCompiler _renderCompiler;
  MessageBasedRenderCompiler(this._brokerFactory, this._renderCompiler) {}
  void start() {
    var broker =
        this._brokerFactory.createMessageBroker(RENDER_COMPILER_CHANNEL);
    broker.registerMethod(
        "compileHost",
        [RenderDirectiveMetadata],
        bind(this._renderCompiler.compileHost, this._renderCompiler),
        ProtoViewDto);
    broker.registerMethod("compile", [ViewDefinition],
        bind(this._renderCompiler.compile, this._renderCompiler), ProtoViewDto);
    broker.registerMethod(
        "mergeProtoViewsRecursively",
        [RenderProtoViewRef],
        bind(this._renderCompiler.mergeProtoViewsRecursively,
            this._renderCompiler),
        RenderProtoViewMergeMapping);
  }
}
